﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Resources.Appearance;

namespace WinChartAxesLayers
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private DataTable GetAreaData()
        {
            DataTable mydata = new DataTable();
            //Define the columns and their names
            mydata.Columns.Add("Column Label", typeof(string));
            mydata.Columns.Add("Point A", typeof(Double));
            mydata.Columns.Add("Point B", typeof(int));

            //Add the rows of data
            mydata.Rows.Add(new Object[] { "Column A", 1.2, null, });
            mydata.Rows.Add(new Object[] { "Column B", 2, 2, });
            mydata.Rows.Add(new Object[] { "Column C", 5.6, 3, });
            mydata.Rows.Add(new Object[] { "Column D", 4, 2, });
            return mydata;
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            ultraChart1.DataSource = GetAreaData();
            ultraChart1.ChartType = ChartType.Composite;
            ultraChart1.CompositeChart.ChartAreas.Add(new ChartArea());
            ultraChart1.CompositeChart.ChartLayers.Add(new ChartLayerAppearance());

            StackAppearance appearance = new StackAppearance();
            appearance.ChartComponent = ultraChart1;
            appearance.StackStyle = StackStyle.Normal;



            //Stack
            ChartLayerAppearance layer = ultraChart1.CompositeChart.ChartLayers[0];
            layer.ChartArea = ultraChart1.CompositeChart.ChartAreas[0];
            layer.ChartType = ChartType.LineChart;        
            layer.AxisX = new AxisItem(ultraChart1, AxisNumber.X_Axis);
            //layer.AxisX.TickmarkStyle = AxisTickStyle.Percentage;
            //ultraChart1.Axis.X.TickmarkStyle = AxisTickStyle.Percentage;
            //ultraChart1.Axis.X.TickmarkInterval = 50;
            layer.AxisX.DataType = AxisDataType.String  ;
            layer.AxisX.Labels.ItemFormat = AxisItemLabelFormat.ItemLabel;
            layer.AxisX.Labels.HorizontalAlign = StringAlignment.Far;
            layer.AxisX.SetLabelAxisType = Infragistics.UltraChart.Core.Layers.SetLabelAxisType.ContinuousData;
            layer.AxisY = new AxisItem(ultraChart1, AxisNumber.Y_Axis);
            layer.AxisY.TickmarkStyle = AxisTickStyle.Smart;
            layer.AxisY.RangeType = AxisRangeType.Automatic;
            layer.AxisY.DataType = AxisDataType.Numeric;
            layer.AxisY.Labels.ItemFormat = AxisItemLabelFormat.DataValue;
            layer.AxisY.Labels.ItemFormatString = "<DATA_VALUE:#0.##>";
            layer.AxisY.SetLabelAxisType = Infragistics.UltraChart.Core.Layers.SetLabelAxisType.ContinuousData;
            layer.ChartArea.Axes.Add(layer.AxisX);
            layer.ChartArea.Axes.Add(layer.AxisY);

            NumericSeries series = new NumericSeries(ultraChart1);
            series.Key = "stack1";
            series.DataBind(GetAreaData(), "Point A");
            series.PEs.Add(new PaintElement() { Fill = Color.Green, ElementType = PaintElementType.Gradient, FillStopColor = Color.Blue, FillGradientStyle = GradientStyle.ForwardDiagonal });
            layer.Series.Add(series);



            ultraChart1.CompositeChart.ChartLayers.Add(new ChartLayerAppearance());
            ChartLayerAppearance layer2 = ultraChart1.CompositeChart.ChartLayers[1];
            layer2.ChartType = ChartType.ColumnChart;
            layer2.ChartArea = ultraChart1.CompositeChart.ChartAreas[0];
            layer2.AxisX = new AxisItem(ultraChart1, AxisNumber.X_Axis);
            layer2.ChartArea.Axes.Add(layer2.AxisX);
            layer2.AxisX.DataType = AxisDataType.String;
            layer2.AxisX.Labels.ItemFormat = AxisItemLabelFormat.None;
            layer2.AxisX.Labels.HorizontalAlign = StringAlignment.Far;
            layer2.AxisX.SetLabelAxisType = Infragistics.UltraChart.Core.Layers.SetLabelAxisType.GroupBySeries;
            layer2.AxisX.Labels.Orientation = TextOrientation.VerticalLeftFacing;
            layer2.AxisY = layer.AxisY;
          
            NumericSeries series2 = new NumericSeries(ultraChart1);
            series2.Key = "stack2";
            series2.DataBind(GetAreaData(), "Point B", "Column Label");
            series2.PEs.Add(new PaintElement(Color.Red));
            layer2.Series.Add(series2);

            NumericSeries series3 = new NumericSeries(ultraChart1);
            series3.Key = "stack3";
            series3.DataBind(GetAreaData(), "Point A");
            series3.PEs.Add(new PaintElement(Color.Yellow));
      
            layer2.Series.Add(series3);
            

            ultraChart1.CompositeChart.Series.Add(series);
            ultraChart1.CompositeChart.Series.Add(series2);
            ultraChart1.CompositeChart.Series.Add(series3);

            ultraChart1.CompositeChart.ChartLayers[1].SwapRowsAndColumns = true;
                     
        }
    }
}
